15. 三数之和

给定一个包含 n 个整数的数组 nums,判断 nums 中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?找出所有满足条件且不重复的三元组。

注意:答案中不可以包含重复的三元组。

例如, 给定数组 nums = [-1, 0, 1, 2, -1, -4],

满足要求的三元组集合为:
[
[-1, 0, 1],
[-1, -1, 2]]

(1)这道题暴力是O(n^3),肯定感觉肯定会蹦的。
(2)那么可以先固定两个数字,第三个元素可以用二分搜索来查找,这样就把时间复杂度下降到O(nlgn)了,但是我写到最后发现结果:

执行用时 : 186 ms, 在3Sum的Java提交中击败了18.92% 的用户
内存消耗 : 48.6 MB, 在3Sum的Java提交中击败了88.18% 的用户

哭了,直接上代码:

    public Integer binarySearch(int[] a, int begin, int end, int target){
        Integer i = null;

        while(begin <= end){
            if(begin == end){
                if(a[begin] == target){
                    i = a[begin];
                }
                return i;
            }

            int mid = (begin + end) / 2;
            if(a[mid] == target){
                i = a[mid];
                return i;
            }
            if(a[mid] < target){
                begin = mid + 1;
            }else{
                end = mid - 1;
            }
        }
        return i;
    }
    public List<List<Integer>> threeSum(int[] nums){

        List<List<Integer>> endList = new ArrayList<>();
        Integer lasti = null;
        Integer lastj = null;
        Integer lastResult = null;
        Arrays.sort(nums);
        int[] a = nums;
        for(int i = 0; i < a.length-2; i++){
            if(lasti != null && a[i] == lasti){
                continue;
            }
            for(int j= i+1; j < a.length-1; j++){
                if(lastj != null && a[j] == lastj){
                    continue;
                }
                Integer result = binarySearch(a, j+1, a.length-1, -a[i]-a[j]);
                if(result != null){
                    List<Integer> list = new ArrayList<>();
                    list.add(a[i]);
                    list.add(a[j]);
                    list.add(result);
                    endList.add(list);
                }
                lastj = a[j];
            }
            lasti = a[i];
            lastj = null;
        }
        return endList;
    }

原文地址:https://www.cnblogs.com/disandafeier/p/10958832.html

时间: 2024-11-09 02:50:31

15. 三数之和的相关文章

15. 三数之和(筛选数据)

给定一个包含 n 个整数的数组 nums,判断 nums 中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?找出所有满足条件且不重复的三元组. 注意:答案中不可以包含重复的三元组. 例如, 给定数组 nums = [-1, 0, 1, 2, -1, -4], 满足要求的三元组集合为:[ [-1, 0, 1], [-1, -1, 2]] 1/** 2 * @param {number[]} nums 3 * @return {number[][]} 4 */ 5 6var th

15.三数之和——LeetCode

1 package threesum; 2 3 import java.util.ArrayList; 4 import java.util.Arrays; 5 import java.util.List; 6 7 /** 8 * 给定一个包含 n 个整数的数组 nums,判断 nums 中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?找出所有满足条件且不重复的三元组. 9 * 注意:答案中不可以包含重复的三元组 10 * 11 * 主要的思想:如果采用暴力法的话,时间复杂

leetcode(15)三数之和+去重

三数之和 解题思路:排序+双指针 class Solution { public List<List<Integer>> threeSum(int[] nums) { List<List<Integer>> result = new ArrayList<List<Integer>>(); if(nums.length<=2){ return result; } List<Integer> item = null; A

LeetCode 15. 三数之和(3Sum)

题目描述 给定一个包含 n 个整数的数组 nums,判断 nums 中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?找出所有满足条件且不重复的三元组. 注意:答案中不可以包含重复的三元组. 例如, 给定数组 nums = [-1, 0, 1, 2, -1, -4], 满足要求的三元组集合为: [ [-1, 0, 1], [-1, -1, 2] ] 解题思路 首先对数组从小到大排序,从一个数开始遍历,若该数大于0,后面的数不可能与其相加和为0,所以跳过:否则该数可能是满足要求

leetcode 15.三数之和

给定一个包含 n 个整数的数组 nums,判断 nums 中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?找出所有满足条件且不重复的三元组. 注意:答案中不可以包含重复的三元组. 例如, 给定数组 nums = [-1, 0, 1, 2, -1, -4], 满足要求的三元组集合为:[ [-1, 0, 1], [-1, -1, 2]] class Solution {public:    vector<vector<int>> threeSum(vector&l

15. 三数之和 (思维)

题目连接: https://leetcode-cn.com/problems/3sum/ 题目大意: 中文题目 具体思路: 使得 a +b +c = 0,这个等式成立有如下情况 1. 都为0 2. 一正两负/两正一负 3. 一正一负一零 观察之后,除了0这种情况,都会存在一个负数,我们可以第一步枚举负数,枚举完之后,再从剩下的数中凑得等式成立 我们将所有的数进行排序之后,第一部分枚举负数,第二部分通过两个指针来凑数 关于去重,如果负数都相同,这个好判断. 需要考虑的是剩下的两个数的去重,我们可以

[Leetcode 15]三数之和 3 Sum

[题目] Given an array nums of n integers, are there elements a, b, c in nums such that a + b + c = 0? Find all unique triplets in the array which gives the sum of zero. Note: The solution set must not contain duplicate triplets. Example: Given array nu

Python版[leetcode]15. 三数之和(难度中等)

给定一个包含 n 个整数的数组 nums,判断 nums 中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?找出所有满足条件且不重复的三元组. 注意:答案中不可以包含重复的三元组. 示例: 给定数组 nums = [-1, 0, 1, 2, -1, -4], 满足要求的三元组集合为:[ [-1, 0, 1], [-1, -1, 2]] 这道题我感觉是有点难度的,一般都是2个数做比较,这次有3个数参与了,没有想到什么好的方法,后来直接找的参考 排序 + 双指针 本题的难点在于如

[LeetCode-Golang] 15. 三数之和

题目 给你一个包含 n 个整数的数组 nums,判断 nums 中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?请你找出所有满足条件且不重复的三元组. 注意:答案中不可以包含重复的三元组. 示例: 给定数组 nums = [-1, 0, 1, 2, -1, -4], 满足要求的三元组集合为:[  [-1, 0, 1],  [-1, -1, 2]] 来源:力扣(LeetCode)链接:https://leetcode-cn.com/problems/3sum著作权归领扣网络所